#!/usr/bin/python

import os
import re
from select import select
from fcntl import fcntl, F_SETFL
from popen2 import Popen3


process = Popen3("cdrecord -v -eject -dummy -dao dev=/dev/hdc speed=4 -data ~/sarge-i386-businesscard.iso", 1)

# Non-blocking, please!
fcntl(process.fromchild.fileno(), F_SETFL, os.O_NONBLOCK)
fcntl(process.tochild.fileno(),   F_SETFL, os.O_NONBLOCK)
fcntl(process.childerr.fileno(),  F_SETFL, os.O_NONBLOCK)

progress_pattern = 'Track \d+:\s+(\d+) of\s+(\d+) MB written'
progress_re = re.compile(progress_pattern)

# Process input
while 1:
    (r, w, e) = select([process.fromchild, ], [], [process.childerr, ], 1)
    for i in r:
        from_process = process.fromchild.read()
        if from_process:
            if re.search(progress_pattern, from_process):
                print progress_re.search(from_process).groups()
            else:
                print from_process, 
    retval = process.poll()
    if retval != -1:
        print "Finished with '%d'" % retval
        break
    else:
        pass

